using System;

public class HelloWorld
{
    public static void Main(string[] args)
    {
        string[] r = Console.ReadLine().Split();
        int n = int.Parse(r[0]), L = int.Parse(r[1]),i,j = 0,k = 0;
        int[] niz = new int[n];
        int[] niz2 = new int[n];
        int[] niz3 = new int[L];
        int[] niz4 = new int[L];
        for(i = 0;i<n;i++)
        {
            r = Console.ReadLine().Split();
            niz[i] = int.Parse(r[0]);
            niz2[i] = int.Parse(r[1]); 
            if(i!=0)
            {
                if((niz[i] - niz[i-1]) < niz2[i-1])
                {
                    niz2[i] += niz2[i-1] - (niz[i] - niz[i-1]);
                    niz2[i-1] = (niz[i] - niz[i-1]);
                }
            }   
        }
        for(i = 0;i<L;i++)
        {
            niz3[i] = int.Parse(Console.ReadLine());
            while(k != n-1 )
            {
                if(niz3[i] > niz[k] && k<n)
                {
                    k++;
                }
                else break;
            }
            for(j = 0;j<k;j++)
            {
                niz4[i]+=niz2[j];
            }
            if(niz3[i] - niz[k] <= niz2[k])
            {
                niz4[i] += niz3[i] - niz[k] + 1;
            }
            else niz4[i] += niz2[k];
        }
        for(i = 0;i<L;i++)
        {
            Console.WriteLine(niz4[i]);
        }
        Console.ReadLine();
    }
}